<?php
/**
 * Plugin Name: Import YTube WTP
 * Description: Import Youtube video as WP content in one click. The plugin works instantly without requires you to create Youtube API Key.
 * Plugin URI: https://wpthemeplugin.org/free-downloads/import-ytube/
 * Author: Leo BCBiz (WpThemePlugin.com)
 * Version: 1.0.3
 * Author URI: https://wpthemeplugin.com/
 * Requires at least: 5.6
 * Requires PHP: 7.0
*/

if(!class_exists('WPThemePluginTools')) {
class WPThemePluginTools {
	private $wpthemeplugin_tools_options;

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'wpthemeplugin_tools_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'wpthemeplugin_tools_page_init' ) );
	}

	public function wpthemeplugin_tools_add_plugin_page() {
	    
		add_menu_page(
			'WPThemePlugin Tools', // page_title
			'WTP Tools', // menu_title
			'manage_options', // capability
			'wpthemeplugin-tools', // menu_slug
			array( $this, 'wpthemeplugin_tools_create_admin_page' ), // function
			'dashicons-yes', // icon_url
			75 // position
		);
		add_submenu_page('wpthemeplugin-tools', 'WTP Tools', 'WTP Tools Dashboard', 'manage_options', 'wpthemeplugin-tools' );
	}

	public function wpthemeplugin_tools_create_admin_page() {
		$this->wpthemeplugin_tools_options = get_option( 'wpthemeplugin_tools_option_name' ); ?>
		
		<style>
		    .wtptools-page {
		        background: #fff;
                padding: 15px 30px 25px;
                margin: 20px 15px 35px;
                max-width: 650px;
                font-size:14px;
                border-radius:10px;
                box-shadow: #e0e0e0 0px 2px 8px 0px;
                line-height:1.5em;
		    }
		    .wtptools-page p {
		        font-size:14px;
		        line-height:1.5em;
		    }
		    .wtptools-page ul {
                margin-top:50px;
		    }
		    .wtptools-page li {
		        font-size:16px;
		        margin-top:25px;
		        margin-bottom:35px;
		    }
		    .wtptools-pluginsection {
		        margin-top:10px;
		        margin-bottom:10px;
		    }
		    .wtptools-pluginpage {
		        float:left;
		        margin-right:35px;
		    }
		    .wtptools-pluginpage a {
		        background:#FF8871;
		        color:#fff;
		        padding:4px 20px 5px;
		        font-size:12px;
		        text-decoration:none;
		        border-radius:2px;
		    }
		    .wtptools-plugindetails a {
		        background:#8871ff;
		        color:#fff;
		        padding:4px 20px 5px;
		        font-size:12px;
		        text-decoration:none;
		        border-radius:2px;
		    }
		    .wtptools-img {
		        float:left;
		        margin:5px 15px 10px 0;
		        max-width:180px;
		    }
		</style>

		<div class="wrap wtptools-page">
		    
			<h2 style="font-size:20px;font-weight:600 !important;">Thank you for using one of our plugins!</h2>
			
			<p>If you enjoy using the plugin, also check out our other premium tools below.</p>
			
			
			<?php
			
			$iyt_getlisttransient = get_transient( 'wtp_s3_list' );
			
			if( false !== $iyt_getlisttransient ) {
			    
			    $iyt_list = $iyt_getlisttransient;
			    
			} else {
			
			    $iyt_list = wp_remote_get( 'https://newsblogempire.s3.amazonaws.com/WTP2023/wtp-premiumtools.json' );
			    set_transient( 'wtp_s3_list', $iyt_list, 300 );
		    
			}
			
			$iyt_retrievelist = wp_remote_retrieve_body( $iyt_list );
            $iyt_getlist = json_decode( $iyt_retrievelist );
			
            ?>
            
            
            <?php
            if ( ( !is_wp_error($iyt_list)) && (200 === wp_remote_retrieve_response_code( $iyt_list ) ) ) { ?>
            
                <ul>
                <?php foreach($iyt_getlist->wtptools->products as $iytlistdata) { ?>
                
                <li><a target="_blank" href="<?php echo $iytlistdata->link; ?>"><img src="<?php echo $iytlistdata->image; ?>" class="wtptools-img" /></a><p><strong><?php echo $iytlistdata->title; ?></strong><br />
			    <?php echo $iytlistdata->description; ?></p>
			        <div class="wtptools-pluginsection">
			            <div class="wtptools-pluginpage">
			                <a href="<?php echo $iytlistdata->link; ?>" target="_blank">Start using this plugin</a>
			            </div>
			        </div>
			        <div style="clear:both;"></div>
			    </li>
                    
                <?php }
                ?>
                </ul>
                
            <?php } else {
            ?>
			
			
			<ul>
			    <li><a target="_blank" href="https://1clickwptools.com/importazon-special-deal/"><img src="https://d2c136330chs5t.cloudfront.net/ImportAzon/importazon-cover-2.png" class="wtptools-img" /></a><p><strong>WP ImportAzon 1-Click Plugin</strong><br />
			    Import Amazon affiliate products to your website, without Amazon API Key. Supports 9 Amazon countries.</p>
			        <div class="wtptools-pluginsection">
			            <div class="wtptools-pluginpage">
			                <a target="_blank" href="https://1clickwptools.com/importazon-special-deal/">Start using this plugin</a>
			            </div>
			        </div>
			        <div style="clear:both;"></div>
			    </li>
			    <li><a target="_blank" href="https://wpthemeplugin.com/get-fresh-ai/"><img src="https://d2c136330chs5t.cloudfront.net/AITools/wp-fresh-ai-cover-3.png" class="wtptools-img" /></a><p><strong>WP Fresh A.I. Plugin</strong><br />
			    Add three A.I. content generator on your own website: text-to-article, text-to-image and 1-click rewriter.</p>
			        <div class="wtptools-pluginsection">
			            <div class="wtptools-pluginpage">
			                <a target="_blank" href="https://wpthemeplugin.com/get-fresh-ai/">Start using this plugin</a>
			            </div>
			        </div>
			        <div style="clear:both;"></div>
			    </li>
			</ul>
			
			<?php }//END if ( ( !is_wp_error($iyt_list)) ?>
		</div>
	<?php }

	public function wpthemeplugin_tools_page_init() {
		register_setting(
			'wpthemeplugin_tools_option_group', // option_group
			'wpthemeplugin_tools_option_name', // option_name
			array( $this, 'wpthemeplugin_tools_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'wpthemeplugin_tools_setting_section', // id
			'', // title
			array( $this, 'wpthemeplugin_tools_section_info' ), // callback
			'wpthemeplugin-tools-admin' // page
		);

		add_settings_field(
			'import_amazon_item_as_0', // id
			'Import Amazon Item As', // title
			array( $this, 'import_amazon_item_as_0_callback' ), // callback
			'wpthemeplugin-tools-admin', // page
			'wpthemeplugin_tools_setting_section' // section
		);
	}

	public function wpthemeplugin_tools_sanitize($input) {
		$sanitary_values = array();
		if ( isset( $input['import_amazon_item_as_0'] ) ) {
			$sanitary_values['import_amazon_item_as_0'] = sanitize_text_field( $input['import_amazon_item_as_0'] );
		}

		return $sanitary_values;
	}

	public function wpthemeplugin_tools_section_info() {
		
	}

	public function import_amazon_item_as_0_callback() {
		printf(
			'<input class="regular-text" type="text" name="wpthemeplugin_tools_option_name[import_amazon_item_as_0]" id="import_amazon_item_as_0" value="%s">',
			isset( $this->wpthemeplugin_tools_options['import_amazon_item_as_0'] ) ? esc_attr( $this->wpthemeplugin_tools_options['import_amazon_item_as_0']) : ''
		);
	}

}
if ( is_admin() )
	$wpthemeplugin_tools = new WPThemePluginTools();
}//END if(!class_exists())

require 'impytube-addtopost.php';
require 'impytube-update.php';
add_action('admin_menu', 'wtptool_add_importytube');
function wtptool_add_importytube(){
     add_submenu_page(
        'wpthemeplugin-tools', //$parent_slug
        'Import YTube',  //$page_title
        'Import YTube',        //$menu_title
        'manage_options',           //$capability
        'wtp-importytube',//$menu_slug
        'render_wtptool_importytube'//$function
     );
}

function render_wtptool_importytube() {
    ?>
    <style>
        .wtptools-page {
            background: #fff;
            padding: 15px 30px 25px;
            margin: 20px 15px 35px;
            max-width: 650px;
            font-size:14px;
            border-radius:10px;
            box-shadow: #e0e0e0 0px 2px 8px 0px;
            line-height:1.5em;
        }
        .wtptools-page p {
            font-size:14px;
            line-height:1.5em;
        }
        .import-ytube-btn {
            background:#FF8871;
            color:#fff;
            padding:4px 20px 5px;
            font-size:14px;
            text-decoration:none;
            border-radius:2px;
            cursor:pointer;
            border:none;
        }
        .import-ytube-btn:hover {
            opacity: 0.9;
        }
        .import-ytube-none {
            display: none;
        }
        .wtptools-page .dashicons {
            font-size:14px;
            vertical-align: middle;
        }
        .importytube-postinfo {
            
        }
        .importytube-countpost,
        .importytube-limitpost {
            float:left;
            margin-right:30px;
            font-size:24px;
            text-align:center;
            padding:10px 20px;
            background:#f7f7f7;
        }
        .importytube-countpost span,
        .importytube-limitpost span {
            font-size:13px;
        }
    </style>
    
    
    
    <div class="wrap wtptools-page">
        
		<h2 style="font-size:20px;font-weight:600 !important;">
            IMPORT YTUBE <a class="wtp-pluginlink" href="https://wpthemeplugin.org/free-downloads/import-ytube/" target="_blank"><span class="dashicons dashicons-admin-links"></span></a>
		</h2>
		
		<p>Import Youtube video as WP content in one click, without Youtube API Key.</p>
		
		<?php
		$impyt_countposts = get_posts(array(
            'post_type'     => 'post',
            'post_status'    => 'any',
            'meta_key'      => 'importytube_meta_vidid'
        ));
        $impyt_totalposts = count($impyt_countposts);
        ?>
        
        <div class="importytube-postinfo">
        <div class="importytube-countpost">
            <?php echo $impyt_totalposts; ?>
            <br />
            <span>Post Created</span>
        </div>
        
        <div class="importytube-limitpost">
            ∞
            <br />
            <span>Import Limit</span>
        </div>
        <div style="clear:both;"></div>
        </div>
        
		<p>Awesome! You may import unlimited Youtube video to your website.</p>
		
		<div style="margin-top:35px;margin-bottom:20px;border-top:1px solid #e1e1e1;padding-top:20px;">
		<form method="post">
            <label for="import-ytube-vidid" style="margin-right:10px;">Enter Youtube Video ID:</label>
            <input placeholder="Example: vGQficynmIY" type="text" name="import-ytube-vidid" id="import-ytube-vidid" required>
            <div style="margin-top:20px;">
            <button type="button" id="import-ytube-generate" class="import-ytube-btn">Import Video to WP Post</button>
            </div>
        </form>
        </div>
        
        <div id="import-ytube-loading"></div>
    
        <div id="import-ytube-box" class="import-ytube-none">
        
            <div id="import-ytube-postbox"></div>
        
        </div>
        <div style="clear:both;"></div>
        
        <script>
            document.getElementById( 'import-ytube-generate' ).addEventListener( 'click', function ( event ) {
		    
			event.preventDefault();
			
			var urlInput = document.getElementById( 'import-ytube-vidid' );
			
			var message = document.getElementById( 'import-ytube-loading' );
			message.innerHTML = '<img src="<?php echo admin_url(); ?>images/spinner.gif" alt="Importing...">';
			message.classList = 'downloading';
			
			var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
			var xhttp = new XMLHttpRequest();
			
			var formData = new FormData();
			formData.append( 'action', 'iytwtp_action' );
			formData.append( 'url', urlInput.value );
			
			xhttp.open( "POST", ajaxurl );
			xhttp.send( formData );
			
			xhttp.onreadystatechange = function () {
				if ( this.readyState === 4 && this.status === 200 ) {
					var data = JSON.parse( this.responseText );
					if ( data.success === true ) {
						message.classList.add( 'updated' );
						message.innerHTML = data.data;
					} else {
						message.classList.add( 'error' );
						message.innerHTML = data.data;
					}
				}
			};
		    } );
        </script>
    </div>

    
    <?php
}



if ( ! function_exists( 'wtp_custom_curl_timeout' ) ) {
    add_action('http_api_curl', 'wtp_custom_curl_timeout', 9999, 1);
    function wtp_custom_curl_timeout( $handle ){
	    curl_setopt( $handle, CURLOPT_CONNECTTIMEOUT, 25 );
	    curl_setopt( $handle, CURLOPT_TIMEOUT, 25 );
    }
}

if ( ! function_exists( 'wtp_custom_http_request_timeout' ) ) {
    add_filter( 'http_request_timeout', 'wtp_custom_http_request_timeout', 9999 );
    function wtp_custom_http_request_timeout( $timeout_value ) {
	    return 25;
    }
}

if ( ! function_exists( 'wtp_custom_http_request_args' ) ) {
    add_filter('http_request_args', 'wtp_custom_http_request_args', 9999, 1);
    function wtp_custom_http_request_args( $r ){
	    $r['timeout'] = 25;
	    return $r;
    }
}